#ifndef headerfiletabs
#define headerfiletabs

#include <windows.h>
#include <commctrl.h>
#include <string>
#include <memory>

#include "resource.h"
#include "messages.h"
#include <ttmath/ttmathtypes.h>
#include "programresources.h"


//#define WM_INIT_TAB_VARIABLES WM_USER+2
//#define WM_INIT_TAB_FUNCTIONS WM_USER+3
//#define WM_INIT_TAB_PRECISION WM_USER+4

#define WM_INIT_TAB_VARIABLES	WM_APP
#define WM_INIT_TAB_FUNCTIONS	WM_APP+1
#define WM_INIT_TAB_PRECISION	WM_APP+2
#define WM_INIT_TAB_DISPLAY		WM_APP+3

namespace TabWindowFunctions
{
extern int tab_standard;
extern int tab_variables;
extern int tab_functions;
extern int tab_precision;
extern int tab_display;

	BOOL CALLBACK TabWindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
	void SetLanguage(HWND hTab);
	void SetSizeOfVariablesList();
	void SetSizeOfFunctionsList();

	namespace Variables
	{
		extern std::string caption,name,value;
		extern bool adding;

		char * ChangeToSmallLetters(char * string);
		char * StripWhiteCharacters(char * string);

		void AddNewItemToVariableList(HWND list, const std::string & name, const std::string & value);

		BOOL WmTabCommand_AddVariable(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
		BOOL WmTabCommand_EditVariable(HWND hWnd, UINT message, WPARAM wParam, LPARAM);
		BOOL WmTabCommand_DeleteVariable(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
	}

	namespace Functions
	{
		extern std::string caption,name,value;
		extern bool adding;

		void AddNewItemToFunctionList(HWND list, const std::string & name, const std::string & value, int parameters);

		BOOL WmTabCommand_AddFunction(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
		BOOL WmTabCommand_EditFunction(HWND hWnd, UINT message, WPARAM wParam, LPARAM);
		BOOL WmTabCommand_DeleteFunction(HWND hWnd, UINT message, WPARAM wParam, LPARAM);
	}
}


#endif
